<template>
  <div>
    <q-item to="/home" exact clickable>
      <q-item-section avatar>
        <q-icon name="home" />
      </q-item-section>
      <q-item-section>
        <q-item-label>Home</q-item-label>
      </q-item-section>
    </q-item>
    <!--  -->
    <q-item v-if="userMangement" to="/user-management" exact clickable>
      <q-item-section avatar>
        <q-icon name="supervisor_account" />
      </q-item-section>
      <q-item-section>
        <q-item-label>User Management</q-item-label>
      </q-item-section>
    </q-item>
    <!--  -->
    <q-item v-if="userInformation" to="/user-information" exact clickable>
      <q-item-section avatar>
        <q-icon name="supervised_user_circle" />
      </q-item-section>
      <q-item-section>
        <q-item-label>User Information</q-item-label>
      </q-item-section>
    </q-item>
    <!--  -->
    <q-item v-if="todo" to="/todo-list" exact clickable>
      <q-item-section avatar>
        <q-icon name="list" />
      </q-item-section>
      <q-item-section>
        <q-item-label>Todo</q-item-label>
      </q-item-section>
    </q-item>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { mapActions } from "vuex";
export default {
  name: "EssentialLink",
  data() {
    return {
      userMangement: true,
      userInformation: true,
      todo: true,
    };
  },
  methods: {
    getPrivilege() {
      this.$axios
        .get(this.host + "/src/php/actions/user-management-priv.php", {
          userId: 51,
        })
        .then((response) => {});
    },
    ...mapActions({
      setUserId: "showcase/userId",
    }),
  },
  computed: {
    ...mapGetters({
      umAccess: "showcase/umAccess",
      umModify: "showcase/umModify",
      uiAccess: "showcase/uiAccess",
      uiAdd: "showcase/uiAdd",
      uiEdit: "showcase/uiEdit",
      uiDelete: "showcase/uiDelete",
      tdAccess: "showcase/tdAccess",
      tdAdd: "showcase/tdAdd",
      tdEdit: "showcase/tdEdit",
      tdDelete: "showcase/tdDelete",
      userId: "showcase/userId",
      userLevel: "showcase/userLevel",
    }),
  },
  created() {
    if (this.userLevel == "staff") {
      // user management control
      if (this.umAccess == "true") {
        this.userMangement = true;
      } else {
        if (this.umModify == "true") {
          this.userMangement = true;
        } else {
          this.userMangement = false;
        }
      }
      // user information control
      if (this.uiAccess == "true") {
        this.userInformation = true;
      } else {
        if (
          this.uiAdd == "true" ||
          this.uiEdit == "true" ||
          this.uiDelete == "true"
        ) {
          this.userInformation = true;
        } else {
          this.userInformation = false;
        }
      }
      // todo control
      if (this.tdAccess == "true") {
        this.todo = true;
      } else {
        if (
          this.tdAdd == "true" ||
          this.tdEdit == "true" ||
          this.tdDelete == "true"
        ) {
          this.todo = true;
        } else {
          this.todo = false;
        }
      }
    }

    this.$axios
      .get(this.host + "/src/php/actions/login.php", {
        withCredentials: true,
      })
      .then((response) => {
        if (response.data.error) {
          this.$router.push({ path: "/" });
        }
      });
  },
};
</script>
